//import groovyx.gpars.actor.DefaultActor
//
//class Trader extends DefaultActor {
//  void act() {
//    loop {
//      react { message ->
//        if (message instanceof Buy)
//          println "Buying $message.quantity shares of $message.name"
//
//        if (message instanceof Sell)
//          println "Selling $message.quantity shares of $message.name"
//      }
//    }
//  }
//}

import groovyx.gpars.actor.DynamicDispatchActor
import groovy.transform.*

class Trader extends DynamicDispatchActor {
  void onMessage(Buy message) {
    println "Buying $message.quantity shares of $message.name"
  }

  void onMessage(Sell message) {
    println "Selling $message.quantity shares of $message.name"
  }
}

@Immutable class Buy {
  String name
  int quantity
}

@Immutable class Sell {
  String name
  int quantity
}


trader = new Trader().start()

trader << new Buy("GOOG", 1000)
trader << new Sell("GOOG", 500)

trader.join(1, java.util.concurrent.TimeUnit.SECONDS)
